#ifndef __H8_LAN_H__
#define __H8_LAN_H__


typedef struct comedia_CMD
{
	unsigned char  Sync;	// Syncode ( = 0xAA )
	unsigned char  CmdID;	// Command ID
	unsigned char  Param1;	// Parameter1 
	unsigned char  Param2;	// Parameter2 
	unsigned char  Param3;	// Parameter3 
	unsigned char  Param4;	// Parameter4 
} comedia_C1098_CMD;

enum
{
	C1098_CMD_INIT		= 0x01,
	C1098_CMD_GETPIC		= 0x04,
	C1098_CMD_SNAP,
	C1098_CMD_SETPACSIZE,
	C1098_CMD_SETBAUD,
	C1098_CMD_RESET,
	C1098_CMD_POWOFF,
	C1098_CMD_DATA,
	C1098_CMD_SYNC		= 0x0d,
	C1098_CMD_ACK,
	C1098_CMD_NAK,
	C1098_CMD_LIGHTFREQ	= 0x13
};

/*
int	getimage_init_task( void );
void	getimage_init_start( void );
void	getimage_powoff( void );
int	getimage( uchar *outbuf, long *data_cnt );
void	C1098_debug();
*/


#define C1098_FALSE			((unsigned char)0x00)
#define C1098_TRUE			((unsigned char)0x01)

#define C1098_RESOLUTION_80x64		((unsigned char)0x01)
#define C1098_RESOLUTION_160x128	((unsigned char)0x03)
#define C1098_RESOLUTION_320x240	((unsigned char)0x05)
#define C1098_RESOLUTION_640x480	((unsigned char)0x07)

#define C1098_SNAPTYPE_COMPRESS		((unsigned char)0x00)
#define C1098_SNAPTYPE_UNCOMPRESS	((unsigned char)0x01)

#define C1098_PICTTYPE_SNAPSHOT		((unsigned char)0x01)
#define C1098_PICTTYPE_PREVIEW		((unsigned char)0x02)
#define C1098_PICTTYPE_JPEGPREVIEW	((unsigned char)0x05)

#define C1098_PACK_HEADER_LENGTH	6




typedef struct _H8_CONTROL_PACKET { 
	unsigned long CommandCode; 
	unsigned long Status; 
	unsigned long TotalPacketCount; 
	unsigned long CurrentPacketCount; 
	unsigned long TotalDataLen; 
	unsigned long DataType; 
	unsigned long CurrentDataLen; 
	unsigned char *pCurrentData;
} H8_CONTROL_PACKET;


typedef struct _tm_long { 
	long tm_sec; 
	long tm_min; 
	long tm_hour; 
	long tm_mday; 
	long tm_mon; 
	long tm_year; 
	long tm_wday; 
	long tm_yday; 
	long tm_isdst;
} TM_LONG;



#define CTRL_PORT			60001
#define	MAX_DATASIZE		(1460 * 2)
#define H8_CTRL_SOCK_SIZE	(1460)

#define H8_CTRL_BUFF_SIZE	(sizeof(H8_CONTROL_PACKET) + 256)

#define	H8_SUCCESS		0
#define	H8_FAIL			0xFFFF

//
// Command
//
enum {
	C1098_INIT = 0x2001,
	C1098_GET_PICTURE,
	C1098_SNAPSHOT,
	C1098_SET_PACKAGE_SIZE,
	C1098_SET_BAUDRATE,
	C1098_RESET,
	C1098_POEWER_OFF,
	C1098_DATA,
	SENS_TEMP,
	SENS_HUMIDITY
};

#define	H8_RES_MASK			0x00000800
#define	H8_SET_TM			0x00001001
#define	H8_SET_MODE			0x00001002
#define H8_RESET			0x00001003
#define GET_SENS			0x00001004
#define	GET_MODE			0x00001005



enum _CAMERA_STATE {
	SYNC_SEND = 0,
	SYNC_ACK_RECVD,
	SYNC_RECVD,
	SYNC_DONE,
	SYNC_DONE_ACK_SEND,
	INIT_SEND,
	INIT_ACK_RECVD,
	SET_BAUD_SEND,
	SET_BAUD_ACK_RECVD,
	POWER_OFF_SEND,
	POWER_OFF_ACK_RECVD,
	RESET_SEND,
	RESET_ACK_RECVD,
	SET_PKG_SIZE_SEND,
	SET_PKG_SIZE_ACK_REDVD,
	GET_PIC_SEND,
	GET_PIC_ACK_RECVD,
	SNAPSHOT_SEND,
	SNAPSHOT_ACK_REDVD,
	DATA_RECVD,
	NAK_SEND,
	NAK_RECVD
}; 


static	unsigned char	ImageInitial = 0;
static	unsigned char	Image_resolution;
static	unsigned char	Image_picttype;
static	unsigned char	Image_snaptype;
static	unsigned short	Image_packsize;
static	unsigned char	imagedate[512];
static	unsigned long	imatge_data_length = 0;
static	unsigned short	imatge_data_count = 0;
static	unsigned char	imageflag = 0;
static	unsigned char	imagereset = 0;


static	comedia_C1098_CMD SendCmd;
static	comedia_C1098_CMD RcvCmd;

static int g_CameraState = 0;	
static long g_ImageMode = 0;
static int	g_NowAction = 0;
static int g_Baudrate = 0;


#endif /* __H8_LAN_H__ */

